# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import gamethread
import usermsg
import cmdlib
import playerlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')
block  = es.import_addon('sam/base/pcontrol')

filters = {'#all':'#alive','#alive':'#alive','#ct':'#ct','#t':'#t'}
fireworktag     = '#greenFIREWORK'
firework_hudtag = 'FIREWORK'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	cmdlib.registerSayCommand('!firework', fireworkCMD,'SAM')
	cmdlib.registerSayCommand('!sam_firework', fireworkCMD,'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	cmdlib.unregisterSayCommand('!firework')
	cmdlib.unregisterSayCommand('!sam_firework')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def fireworkCMD(userid, args):
	admin = playerlib.getPlayer(userid)
	if admins.isAdmin(admin.steamid):
		if admins.checkAccess(admin.steamid, 'Firework'):
			if args:
				if not args[0] in filters:
					try: moduleAction(admin, playerlib.getPlayer(es.getuserid(args[0])), 0, 1)
					except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), firework_hudtag)
				else:
					list = playerlib.getPlayerList(filters[args[0]])
					for ply in list:
						if admins.checkImmunity(es.getplayersteamid(userid), ply.steamid, 0): moduleAction(admin, ply, 1, 1)
						else: list.remove(ply)
					if len(list) > 0: func.tell('#all', func.lang_pcontrol('firework_multi_targets', {'num':len(list)}), fireworktag)
			else: block.function(userid, 'Firework', None)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid, target, cmd=0, menu=0):
	if cmd == 0: func.tell('#all', func.lang_pcontrol('firework_target', {'target':target.name}), fireworktag)
	func.sound(target, 'weapons\physgun_off.wav', 1, 0.5)
	if target.isdead == 0: es.server.insertcmd('usermsg shake %s 100 2' % target)
	gamethread.delayedname(0.1, 'sam_firework_%s' % target, push, (target, 20))
	gamethread.delayedname(0.2, 'sam_firework_%s' % target, push, (target, 45))
	gamethread.delayedname(0.3, 'sam_firework_%s' % target, push, (target, 80))
	gamethread.delayedname(0.4, 'sam_firework_%s' % target, push, (target, 125))
	gamethread.delayedname(0.5, 'sam_firework_%s' % target, push, (target, 180))
	gamethread.delayedname(0.6, 'sam_firework_%s' % target, push, (target, 245))
	gamethread.delayedname(0.7, 'sam_firework_%s' % target, push, (target, 320))
	gamethread.delayedname(0.8, 'sam_firework_%s' % target, push, (target, 405))
	gamethread.delayedname(0.9, 'sam_firework_%s' % target, push, (target, 500))
	gamethread.delayedname(0.9, 'sam_firework_%s' % target, push, (target, 520))
	gamethread.delayedname(1.4, 'sam_firework_%s' % target, func.sound, (target, 'weapons\c4\c4_beep1.wav', 1, 0.5))
	gamethread.delayedname(1.5, 'sam_firework_%s' % target, func.sound, (target, 'weapons\c4\c4_beep1.wav', 1, 0.5))
	gamethread.delayedname(1.7, 'sam_firework_%s' % target, explosion, (target))
	gamethread.delayedname(1.7, 'sam_firework_%s' % target, func.sound, (target, 'weapons/hegrenade/explode4.wav', 1, 0.5))
	if menu == 0: block.function(userid, 'Firework', None)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def explosion(target):
	if target.isdead == 0:
		x,y,z = es.getplayerlocation(target)
		es.server.queuecmd('es_xeffect sparks %s,%s,%s 9999 3 0,0,0' % (x, y, z))
		target.kill()

# ============================================================================================================================================================ #
def push(target, push):
	if target.isdead == 0: es.setplayerprop(target, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', '0,0,%s' % (push))

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_death(ev): gamethread.cancelDelayed('sam_firework_%s' % ev['userid'])

# ============================================================================================================================================================= #
