# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import playerlib
import cmdlib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')
block  = es.import_addon('sam/base/pcontrol')

# * VARIABLES

filters = {'#all':'#alive','#alive':'#alive','#ct':'#ct','#t':'#t'}
slaytag     = '#greenSLAY'
slay_hudtag = 'SLAY'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	cmdlib.registerSayCommand('!slay', slayCMD,'SAM')
	cmdlib.registerSayCommand('!sam_slay', slayCMD,'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	cmdlib.unregisterSayCommand('!slay')
	cmdlib.unregisterSayCommand('!sam_slay')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def slayCMD(userid, args):
	admin = playerlib.getPlayer(userid)
	if admins.isAdmin(admin.steamid):
		if admins.checkAccess(admin.steamid, 'Slay'):
			if args:
				if not args[0] in filters:
					try: moduleAction(admin, playerlib.getPlayer(es.getuserid(args[0])), 0, 1)
					except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), slay_hudtag)
				else:
					list = playerlib.getPlayerList(filters[args[0]])
					for ply in list:
						if admins.checkImmunity(es.getplayersteamid(userid), ply.steamid, 0): moduleAction(admin, ply, 1, 1)
						else: list.remove(ply)
					if len(list) > 0: func.tell('#all', func.lang_pcontrol('slay_multi_targets', {'num':len(list)}), slaytag)
			else: block.function(userid, 'Slay', None)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid, target, cmd=0, menu=0):
	if target:
		if not target.isdead == True:
			target.slay()
			if cmd == 0: func.tell('#human', func.lang_pcontrol('slay_one_target', {'target':target.name}), slaytag)
		else:
			if cmd == 0: func.hudhint(userid, func.lang_pcontrol('slay_target_is_dead', {'target':target.name}), slay_hudtag)
	if menu == 0: block.function(userid, 'Slay', None)

# ============================================================================================================================================================= #